// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safevisionary_interfaces:msg/CameraIO.idl
// generated code does not contain a copyright notice
#include "sick_safevisionary_interfaces/msg/detail/camera_io__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `configured`
#include "sick_safevisionary_interfaces/msg/detail/io_configured__functions.h"
// Member `direction`
#include "sick_safevisionary_interfaces/msg/detail/io_direction__functions.h"
// Member `input_values`
#include "sick_safevisionary_interfaces/msg/detail/io_input_values__functions.h"
// Member `output_values`
#include "sick_safevisionary_interfaces/msg/detail/io_output_values__functions.h"
// Member `ossds_state`
#include "sick_safevisionary_interfaces/msg/detail/ioossds_state__functions.h"

bool
sick_safevisionary_interfaces__msg__CameraIO__init(sick_safevisionary_interfaces__msg__CameraIO * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    sick_safevisionary_interfaces__msg__CameraIO__fini(msg);
    return false;
  }
  // configured
  if (!sick_safevisionary_interfaces__msg__IOConfigured__init(&msg->configured)) {
    sick_safevisionary_interfaces__msg__CameraIO__fini(msg);
    return false;
  }
  // direction
  if (!sick_safevisionary_interfaces__msg__IODirection__init(&msg->direction)) {
    sick_safevisionary_interfaces__msg__CameraIO__fini(msg);
    return false;
  }
  // input_values
  if (!sick_safevisionary_interfaces__msg__IOInputValues__init(&msg->input_values)) {
    sick_safevisionary_interfaces__msg__CameraIO__fini(msg);
    return false;
  }
  // output_values
  if (!sick_safevisionary_interfaces__msg__IOOutputValues__init(&msg->output_values)) {
    sick_safevisionary_interfaces__msg__CameraIO__fini(msg);
    return false;
  }
  // ossds_state
  if (!sick_safevisionary_interfaces__msg__IOOSSDSState__init(&msg->ossds_state)) {
    sick_safevisionary_interfaces__msg__CameraIO__fini(msg);
    return false;
  }
  // ossds_dyn_count
  // ossds_crc
  // ossds_io_status
  // dynamic_speed_a
  // dynamic_speed_b
  // dynamic_valid_flags
  return true;
}

void
sick_safevisionary_interfaces__msg__CameraIO__fini(sick_safevisionary_interfaces__msg__CameraIO * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // configured
  sick_safevisionary_interfaces__msg__IOConfigured__fini(&msg->configured);
  // direction
  sick_safevisionary_interfaces__msg__IODirection__fini(&msg->direction);
  // input_values
  sick_safevisionary_interfaces__msg__IOInputValues__fini(&msg->input_values);
  // output_values
  sick_safevisionary_interfaces__msg__IOOutputValues__fini(&msg->output_values);
  // ossds_state
  sick_safevisionary_interfaces__msg__IOOSSDSState__fini(&msg->ossds_state);
  // ossds_dyn_count
  // ossds_crc
  // ossds_io_status
  // dynamic_speed_a
  // dynamic_speed_b
  // dynamic_valid_flags
}

bool
sick_safevisionary_interfaces__msg__CameraIO__are_equal(const sick_safevisionary_interfaces__msg__CameraIO * lhs, const sick_safevisionary_interfaces__msg__CameraIO * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // configured
  if (!sick_safevisionary_interfaces__msg__IOConfigured__are_equal(
      &(lhs->configured), &(rhs->configured)))
  {
    return false;
  }
  // direction
  if (!sick_safevisionary_interfaces__msg__IODirection__are_equal(
      &(lhs->direction), &(rhs->direction)))
  {
    return false;
  }
  // input_values
  if (!sick_safevisionary_interfaces__msg__IOInputValues__are_equal(
      &(lhs->input_values), &(rhs->input_values)))
  {
    return false;
  }
  // output_values
  if (!sick_safevisionary_interfaces__msg__IOOutputValues__are_equal(
      &(lhs->output_values), &(rhs->output_values)))
  {
    return false;
  }
  // ossds_state
  if (!sick_safevisionary_interfaces__msg__IOOSSDSState__are_equal(
      &(lhs->ossds_state), &(rhs->ossds_state)))
  {
    return false;
  }
  // ossds_dyn_count
  if (lhs->ossds_dyn_count != rhs->ossds_dyn_count) {
    return false;
  }
  // ossds_crc
  if (lhs->ossds_crc != rhs->ossds_crc) {
    return false;
  }
  // ossds_io_status
  if (lhs->ossds_io_status != rhs->ossds_io_status) {
    return false;
  }
  // dynamic_speed_a
  if (lhs->dynamic_speed_a != rhs->dynamic_speed_a) {
    return false;
  }
  // dynamic_speed_b
  if (lhs->dynamic_speed_b != rhs->dynamic_speed_b) {
    return false;
  }
  // dynamic_valid_flags
  if (lhs->dynamic_valid_flags != rhs->dynamic_valid_flags) {
    return false;
  }
  return true;
}

bool
sick_safevisionary_interfaces__msg__CameraIO__copy(
  const sick_safevisionary_interfaces__msg__CameraIO * input,
  sick_safevisionary_interfaces__msg__CameraIO * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // configured
  if (!sick_safevisionary_interfaces__msg__IOConfigured__copy(
      &(input->configured), &(output->configured)))
  {
    return false;
  }
  // direction
  if (!sick_safevisionary_interfaces__msg__IODirection__copy(
      &(input->direction), &(output->direction)))
  {
    return false;
  }
  // input_values
  if (!sick_safevisionary_interfaces__msg__IOInputValues__copy(
      &(input->input_values), &(output->input_values)))
  {
    return false;
  }
  // output_values
  if (!sick_safevisionary_interfaces__msg__IOOutputValues__copy(
      &(input->output_values), &(output->output_values)))
  {
    return false;
  }
  // ossds_state
  if (!sick_safevisionary_interfaces__msg__IOOSSDSState__copy(
      &(input->ossds_state), &(output->ossds_state)))
  {
    return false;
  }
  // ossds_dyn_count
  output->ossds_dyn_count = input->ossds_dyn_count;
  // ossds_crc
  output->ossds_crc = input->ossds_crc;
  // ossds_io_status
  output->ossds_io_status = input->ossds_io_status;
  // dynamic_speed_a
  output->dynamic_speed_a = input->dynamic_speed_a;
  // dynamic_speed_b
  output->dynamic_speed_b = input->dynamic_speed_b;
  // dynamic_valid_flags
  output->dynamic_valid_flags = input->dynamic_valid_flags;
  return true;
}

sick_safevisionary_interfaces__msg__CameraIO *
sick_safevisionary_interfaces__msg__CameraIO__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__CameraIO * msg = (sick_safevisionary_interfaces__msg__CameraIO *)allocator.allocate(sizeof(sick_safevisionary_interfaces__msg__CameraIO), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safevisionary_interfaces__msg__CameraIO));
  bool success = sick_safevisionary_interfaces__msg__CameraIO__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
sick_safevisionary_interfaces__msg__CameraIO__destroy(sick_safevisionary_interfaces__msg__CameraIO * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    sick_safevisionary_interfaces__msg__CameraIO__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
sick_safevisionary_interfaces__msg__CameraIO__Sequence__init(sick_safevisionary_interfaces__msg__CameraIO__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__CameraIO * data = NULL;

  if (size) {
    data = (sick_safevisionary_interfaces__msg__CameraIO *)allocator.zero_allocate(size, sizeof(sick_safevisionary_interfaces__msg__CameraIO), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safevisionary_interfaces__msg__CameraIO__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safevisionary_interfaces__msg__CameraIO__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safevisionary_interfaces__msg__CameraIO__Sequence__fini(sick_safevisionary_interfaces__msg__CameraIO__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safevisionary_interfaces__msg__CameraIO__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safevisionary_interfaces__msg__CameraIO__Sequence *
sick_safevisionary_interfaces__msg__CameraIO__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__CameraIO__Sequence * array = (sick_safevisionary_interfaces__msg__CameraIO__Sequence *)allocator.allocate(sizeof(sick_safevisionary_interfaces__msg__CameraIO__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = sick_safevisionary_interfaces__msg__CameraIO__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
sick_safevisionary_interfaces__msg__CameraIO__Sequence__destroy(sick_safevisionary_interfaces__msg__CameraIO__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    sick_safevisionary_interfaces__msg__CameraIO__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
sick_safevisionary_interfaces__msg__CameraIO__Sequence__are_equal(const sick_safevisionary_interfaces__msg__CameraIO__Sequence * lhs, const sick_safevisionary_interfaces__msg__CameraIO__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!sick_safevisionary_interfaces__msg__CameraIO__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
sick_safevisionary_interfaces__msg__CameraIO__Sequence__copy(
  const sick_safevisionary_interfaces__msg__CameraIO__Sequence * input,
  sick_safevisionary_interfaces__msg__CameraIO__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(sick_safevisionary_interfaces__msg__CameraIO);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    sick_safevisionary_interfaces__msg__CameraIO * data =
      (sick_safevisionary_interfaces__msg__CameraIO *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!sick_safevisionary_interfaces__msg__CameraIO__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          sick_safevisionary_interfaces__msg__CameraIO__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!sick_safevisionary_interfaces__msg__CameraIO__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
