// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from sick_safevisionary_interfaces:msg/DeviceStatus.idl
// generated code does not contain a copyright notice

#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__DEVICE_STATUS__TRAITS_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__DEVICE_STATUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "sick_safevisionary_interfaces/msg/detail/device_status__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'general_status'
#include "sick_safevisionary_interfaces/msg/detail/general_status__traits.hpp"
// Member 'active_monitoring_case'
#include "sick_safevisionary_interfaces/msg/detail/active_monitoring_case__traits.hpp"

namespace sick_safevisionary_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const DeviceStatus & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: general_status
  {
    out << "general_status: ";
    to_flow_style_yaml(msg.general_status, out);
    out << ", ";
  }

  // member: cop_safety_related
  {
    out << "cop_safety_related: ";
    rosidl_generator_traits::value_to_yaml(msg.cop_safety_related, out);
    out << ", ";
  }

  // member: cop_non_safety_related
  {
    out << "cop_non_safety_related: ";
    rosidl_generator_traits::value_to_yaml(msg.cop_non_safety_related, out);
    out << ", ";
  }

  // member: cop_reset_required
  {
    out << "cop_reset_required: ";
    rosidl_generator_traits::value_to_yaml(msg.cop_reset_required, out);
    out << ", ";
  }

  // member: active_monitoring_case
  {
    out << "active_monitoring_case: ";
    to_flow_style_yaml(msg.active_monitoring_case, out);
    out << ", ";
  }

  // member: contamination_level
  {
    out << "contamination_level: ";
    rosidl_generator_traits::value_to_yaml(msg.contamination_level, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DeviceStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: general_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "general_status:\n";
    to_block_style_yaml(msg.general_status, out, indentation + 2);
  }

  // member: cop_safety_related
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cop_safety_related: ";
    rosidl_generator_traits::value_to_yaml(msg.cop_safety_related, out);
    out << "\n";
  }

  // member: cop_non_safety_related
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cop_non_safety_related: ";
    rosidl_generator_traits::value_to_yaml(msg.cop_non_safety_related, out);
    out << "\n";
  }

  // member: cop_reset_required
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cop_reset_required: ";
    rosidl_generator_traits::value_to_yaml(msg.cop_reset_required, out);
    out << "\n";
  }

  // member: active_monitoring_case
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "active_monitoring_case:\n";
    to_block_style_yaml(msg.active_monitoring_case, out, indentation + 2);
  }

  // member: contamination_level
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "contamination_level: ";
    rosidl_generator_traits::value_to_yaml(msg.contamination_level, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DeviceStatus & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use sick_safevisionary_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const sick_safevisionary_interfaces::msg::DeviceStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  sick_safevisionary_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use sick_safevisionary_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const sick_safevisionary_interfaces::msg::DeviceStatus & msg)
{
  return sick_safevisionary_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<sick_safevisionary_interfaces::msg::DeviceStatus>()
{
  return "sick_safevisionary_interfaces::msg::DeviceStatus";
}

template<>
inline const char * name<sick_safevisionary_interfaces::msg::DeviceStatus>()
{
  return "sick_safevisionary_interfaces/msg/DeviceStatus";
}

template<>
struct has_fixed_size<sick_safevisionary_interfaces::msg::DeviceStatus>
  : std::integral_constant<bool, has_fixed_size<sick_safevisionary_interfaces::msg::ActiveMonitoringCase>::value && has_fixed_size<sick_safevisionary_interfaces::msg::GeneralStatus>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<sick_safevisionary_interfaces::msg::DeviceStatus>
  : std::integral_constant<bool, has_bounded_size<sick_safevisionary_interfaces::msg::ActiveMonitoringCase>::value && has_bounded_size<sick_safevisionary_interfaces::msg::GeneralStatus>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<sick_safevisionary_interfaces::msg::DeviceStatus>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__DEVICE_STATUS__TRAITS_HPP_
