// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from sick_safevisionary_interfaces:msg/GeneralStatus.idl
// generated code does not contain a copyright notice

#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__GENERAL_STATUS__TRAITS_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__GENERAL_STATUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "sick_safevisionary_interfaces/msg/detail/general_status__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace sick_safevisionary_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const GeneralStatus & msg,
  std::ostream & out)
{
  out << "{";
  // member: run_mode_active
  {
    out << "run_mode_active: ";
    rosidl_generator_traits::value_to_yaml(msg.run_mode_active, out);
    out << ", ";
  }

  // member: device_error
  {
    out << "device_error: ";
    rosidl_generator_traits::value_to_yaml(msg.device_error, out);
    out << ", ";
  }

  // member: application_error
  {
    out << "application_error: ";
    rosidl_generator_traits::value_to_yaml(msg.application_error, out);
    out << ", ";
  }

  // member: sleep_mode
  {
    out << "sleep_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.sleep_mode, out);
    out << ", ";
  }

  // member: wait_for_input
  {
    out << "wait_for_input: ";
    rosidl_generator_traits::value_to_yaml(msg.wait_for_input, out);
    out << ", ";
  }

  // member: wait_for_cluster
  {
    out << "wait_for_cluster: ";
    rosidl_generator_traits::value_to_yaml(msg.wait_for_cluster, out);
    out << ", ";
  }

  // member: contamination_warning
  {
    out << "contamination_warning: ";
    rosidl_generator_traits::value_to_yaml(msg.contamination_warning, out);
    out << ", ";
  }

  // member: contamination_error
  {
    out << "contamination_error: ";
    rosidl_generator_traits::value_to_yaml(msg.contamination_error, out);
    out << ", ";
  }

  // member: dead_zone_detection
  {
    out << "dead_zone_detection: ";
    rosidl_generator_traits::value_to_yaml(msg.dead_zone_detection, out);
    out << ", ";
  }

  // member: temperature_warning
  {
    out << "temperature_warning: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature_warning, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GeneralStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: run_mode_active
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "run_mode_active: ";
    rosidl_generator_traits::value_to_yaml(msg.run_mode_active, out);
    out << "\n";
  }

  // member: device_error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "device_error: ";
    rosidl_generator_traits::value_to_yaml(msg.device_error, out);
    out << "\n";
  }

  // member: application_error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "application_error: ";
    rosidl_generator_traits::value_to_yaml(msg.application_error, out);
    out << "\n";
  }

  // member: sleep_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sleep_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.sleep_mode, out);
    out << "\n";
  }

  // member: wait_for_input
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "wait_for_input: ";
    rosidl_generator_traits::value_to_yaml(msg.wait_for_input, out);
    out << "\n";
  }

  // member: wait_for_cluster
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "wait_for_cluster: ";
    rosidl_generator_traits::value_to_yaml(msg.wait_for_cluster, out);
    out << "\n";
  }

  // member: contamination_warning
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "contamination_warning: ";
    rosidl_generator_traits::value_to_yaml(msg.contamination_warning, out);
    out << "\n";
  }

  // member: contamination_error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "contamination_error: ";
    rosidl_generator_traits::value_to_yaml(msg.contamination_error, out);
    out << "\n";
  }

  // member: dead_zone_detection
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dead_zone_detection: ";
    rosidl_generator_traits::value_to_yaml(msg.dead_zone_detection, out);
    out << "\n";
  }

  // member: temperature_warning
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "temperature_warning: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature_warning, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GeneralStatus & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use sick_safevisionary_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const sick_safevisionary_interfaces::msg::GeneralStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  sick_safevisionary_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use sick_safevisionary_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const sick_safevisionary_interfaces::msg::GeneralStatus & msg)
{
  return sick_safevisionary_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<sick_safevisionary_interfaces::msg::GeneralStatus>()
{
  return "sick_safevisionary_interfaces::msg::GeneralStatus";
}

template<>
inline const char * name<sick_safevisionary_interfaces::msg::GeneralStatus>()
{
  return "sick_safevisionary_interfaces/msg/GeneralStatus";
}

template<>
struct has_fixed_size<sick_safevisionary_interfaces::msg::GeneralStatus>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<sick_safevisionary_interfaces::msg::GeneralStatus>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<sick_safevisionary_interfaces::msg::GeneralStatus>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__GENERAL_STATUS__TRAITS_HPP_
