// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from sick_safevisionary_interfaces:msg/ROIObservationSafetyData.idl
// generated code does not contain a copyright notice

#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI_OBSERVATION_SAFETY_DATA__STRUCT_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI_OBSERVATION_SAFETY_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__sick_safevisionary_interfaces__msg__ROIObservationSafetyData __attribute__((deprecated))
#else
# define DEPRECATED__sick_safevisionary_interfaces__msg__ROIObservationSafetyData __declspec(deprecated)
#endif

namespace sick_safevisionary_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ROIObservationSafetyData_
{
  using Type = ROIObservationSafetyData_<ContainerAllocator>;

  explicit ROIObservationSafetyData_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->invalid_due_to_invalid_pixels = 0;
      this->invalid_due_to_variance = 0;
      this->invalid_due_to_overexposure = 0;
      this->invalid_due_to_underexposure = 0;
      this->invalid_due_to_temporal_variance = 0;
      this->invalid_due_to_outside_of_measurement_range = 0;
      this->invalid_due_to_retro_reflector_interference = 0;
      this->contamination_error = 0;
      this->quality_class = 0;
      this->slot_active = 0;
    }
  }

  explicit ROIObservationSafetyData_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->invalid_due_to_invalid_pixels = 0;
      this->invalid_due_to_variance = 0;
      this->invalid_due_to_overexposure = 0;
      this->invalid_due_to_underexposure = 0;
      this->invalid_due_to_temporal_variance = 0;
      this->invalid_due_to_outside_of_measurement_range = 0;
      this->invalid_due_to_retro_reflector_interference = 0;
      this->contamination_error = 0;
      this->quality_class = 0;
      this->slot_active = 0;
    }
  }

  // field types and members
  using _invalid_due_to_invalid_pixels_type =
    uint8_t;
  _invalid_due_to_invalid_pixels_type invalid_due_to_invalid_pixels;
  using _invalid_due_to_variance_type =
    uint8_t;
  _invalid_due_to_variance_type invalid_due_to_variance;
  using _invalid_due_to_overexposure_type =
    uint8_t;
  _invalid_due_to_overexposure_type invalid_due_to_overexposure;
  using _invalid_due_to_underexposure_type =
    uint8_t;
  _invalid_due_to_underexposure_type invalid_due_to_underexposure;
  using _invalid_due_to_temporal_variance_type =
    uint8_t;
  _invalid_due_to_temporal_variance_type invalid_due_to_temporal_variance;
  using _invalid_due_to_outside_of_measurement_range_type =
    uint8_t;
  _invalid_due_to_outside_of_measurement_range_type invalid_due_to_outside_of_measurement_range;
  using _invalid_due_to_retro_reflector_interference_type =
    uint8_t;
  _invalid_due_to_retro_reflector_interference_type invalid_due_to_retro_reflector_interference;
  using _contamination_error_type =
    uint8_t;
  _contamination_error_type contamination_error;
  using _quality_class_type =
    uint8_t;
  _quality_class_type quality_class;
  using _slot_active_type =
    uint8_t;
  _slot_active_type slot_active;

  // setters for named parameter idiom
  Type & set__invalid_due_to_invalid_pixels(
    const uint8_t & _arg)
  {
    this->invalid_due_to_invalid_pixels = _arg;
    return *this;
  }
  Type & set__invalid_due_to_variance(
    const uint8_t & _arg)
  {
    this->invalid_due_to_variance = _arg;
    return *this;
  }
  Type & set__invalid_due_to_overexposure(
    const uint8_t & _arg)
  {
    this->invalid_due_to_overexposure = _arg;
    return *this;
  }
  Type & set__invalid_due_to_underexposure(
    const uint8_t & _arg)
  {
    this->invalid_due_to_underexposure = _arg;
    return *this;
  }
  Type & set__invalid_due_to_temporal_variance(
    const uint8_t & _arg)
  {
    this->invalid_due_to_temporal_variance = _arg;
    return *this;
  }
  Type & set__invalid_due_to_outside_of_measurement_range(
    const uint8_t & _arg)
  {
    this->invalid_due_to_outside_of_measurement_range = _arg;
    return *this;
  }
  Type & set__invalid_due_to_retro_reflector_interference(
    const uint8_t & _arg)
  {
    this->invalid_due_to_retro_reflector_interference = _arg;
    return *this;
  }
  Type & set__contamination_error(
    const uint8_t & _arg)
  {
    this->contamination_error = _arg;
    return *this;
  }
  Type & set__quality_class(
    const uint8_t & _arg)
  {
    this->quality_class = _arg;
    return *this;
  }
  Type & set__slot_active(
    const uint8_t & _arg)
  {
    this->slot_active = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<ContainerAllocator> *;
  using ConstRawPtr =
    const sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__ROIObservationSafetyData
    std::shared_ptr<sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__ROIObservationSafetyData
    std::shared_ptr<sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROIObservationSafetyData_ & other) const
  {
    if (this->invalid_due_to_invalid_pixels != other.invalid_due_to_invalid_pixels) {
      return false;
    }
    if (this->invalid_due_to_variance != other.invalid_due_to_variance) {
      return false;
    }
    if (this->invalid_due_to_overexposure != other.invalid_due_to_overexposure) {
      return false;
    }
    if (this->invalid_due_to_underexposure != other.invalid_due_to_underexposure) {
      return false;
    }
    if (this->invalid_due_to_temporal_variance != other.invalid_due_to_temporal_variance) {
      return false;
    }
    if (this->invalid_due_to_outside_of_measurement_range != other.invalid_due_to_outside_of_measurement_range) {
      return false;
    }
    if (this->invalid_due_to_retro_reflector_interference != other.invalid_due_to_retro_reflector_interference) {
      return false;
    }
    if (this->contamination_error != other.contamination_error) {
      return false;
    }
    if (this->quality_class != other.quality_class) {
      return false;
    }
    if (this->slot_active != other.slot_active) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROIObservationSafetyData_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROIObservationSafetyData_

// alias to use template instance with default allocator
using ROIObservationSafetyData =
  sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI_OBSERVATION_SAFETY_DATA__STRUCT_HPP_
