// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safevisionary_interfaces:msg/DeviceStatus.idl
// generated code does not contain a copyright notice
#include "sick_safevisionary_interfaces/msg/detail/device_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `general_status`
#include "sick_safevisionary_interfaces/msg/detail/general_status__functions.h"
// Member `active_monitoring_case`
#include "sick_safevisionary_interfaces/msg/detail/active_monitoring_case__functions.h"

bool
sick_safevisionary_interfaces__msg__DeviceStatus__init(sick_safevisionary_interfaces__msg__DeviceStatus * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    sick_safevisionary_interfaces__msg__DeviceStatus__fini(msg);
    return false;
  }
  // status
  // general_status
  if (!sick_safevisionary_interfaces__msg__GeneralStatus__init(&msg->general_status)) {
    sick_safevisionary_interfaces__msg__DeviceStatus__fini(msg);
    return false;
  }
  // cop_safety_related
  // cop_non_safety_related
  // cop_reset_required
  // active_monitoring_case
  if (!sick_safevisionary_interfaces__msg__ActiveMonitoringCase__init(&msg->active_monitoring_case)) {
    sick_safevisionary_interfaces__msg__DeviceStatus__fini(msg);
    return false;
  }
  // contamination_level
  return true;
}

void
sick_safevisionary_interfaces__msg__DeviceStatus__fini(sick_safevisionary_interfaces__msg__DeviceStatus * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // status
  // general_status
  sick_safevisionary_interfaces__msg__GeneralStatus__fini(&msg->general_status);
  // cop_safety_related
  // cop_non_safety_related
  // cop_reset_required
  // active_monitoring_case
  sick_safevisionary_interfaces__msg__ActiveMonitoringCase__fini(&msg->active_monitoring_case);
  // contamination_level
}

bool
sick_safevisionary_interfaces__msg__DeviceStatus__are_equal(const sick_safevisionary_interfaces__msg__DeviceStatus * lhs, const sick_safevisionary_interfaces__msg__DeviceStatus * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  // general_status
  if (!sick_safevisionary_interfaces__msg__GeneralStatus__are_equal(
      &(lhs->general_status), &(rhs->general_status)))
  {
    return false;
  }
  // cop_safety_related
  if (lhs->cop_safety_related != rhs->cop_safety_related) {
    return false;
  }
  // cop_non_safety_related
  if (lhs->cop_non_safety_related != rhs->cop_non_safety_related) {
    return false;
  }
  // cop_reset_required
  if (lhs->cop_reset_required != rhs->cop_reset_required) {
    return false;
  }
  // active_monitoring_case
  if (!sick_safevisionary_interfaces__msg__ActiveMonitoringCase__are_equal(
      &(lhs->active_monitoring_case), &(rhs->active_monitoring_case)))
  {
    return false;
  }
  // contamination_level
  if (lhs->contamination_level != rhs->contamination_level) {
    return false;
  }
  return true;
}

bool
sick_safevisionary_interfaces__msg__DeviceStatus__copy(
  const sick_safevisionary_interfaces__msg__DeviceStatus * input,
  sick_safevisionary_interfaces__msg__DeviceStatus * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // status
  output->status = input->status;
  // general_status
  if (!sick_safevisionary_interfaces__msg__GeneralStatus__copy(
      &(input->general_status), &(output->general_status)))
  {
    return false;
  }
  // cop_safety_related
  output->cop_safety_related = input->cop_safety_related;
  // cop_non_safety_related
  output->cop_non_safety_related = input->cop_non_safety_related;
  // cop_reset_required
  output->cop_reset_required = input->cop_reset_required;
  // active_monitoring_case
  if (!sick_safevisionary_interfaces__msg__ActiveMonitoringCase__copy(
      &(input->active_monitoring_case), &(output->active_monitoring_case)))
  {
    return false;
  }
  // contamination_level
  output->contamination_level = input->contamination_level;
  return true;
}

sick_safevisionary_interfaces__msg__DeviceStatus *
sick_safevisionary_interfaces__msg__DeviceStatus__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__DeviceStatus * msg = (sick_safevisionary_interfaces__msg__DeviceStatus *)allocator.allocate(sizeof(sick_safevisionary_interfaces__msg__DeviceStatus), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safevisionary_interfaces__msg__DeviceStatus));
  bool success = sick_safevisionary_interfaces__msg__DeviceStatus__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
sick_safevisionary_interfaces__msg__DeviceStatus__destroy(sick_safevisionary_interfaces__msg__DeviceStatus * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    sick_safevisionary_interfaces__msg__DeviceStatus__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
sick_safevisionary_interfaces__msg__DeviceStatus__Sequence__init(sick_safevisionary_interfaces__msg__DeviceStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__DeviceStatus * data = NULL;

  if (size) {
    data = (sick_safevisionary_interfaces__msg__DeviceStatus *)allocator.zero_allocate(size, sizeof(sick_safevisionary_interfaces__msg__DeviceStatus), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safevisionary_interfaces__msg__DeviceStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safevisionary_interfaces__msg__DeviceStatus__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safevisionary_interfaces__msg__DeviceStatus__Sequence__fini(sick_safevisionary_interfaces__msg__DeviceStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safevisionary_interfaces__msg__DeviceStatus__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safevisionary_interfaces__msg__DeviceStatus__Sequence *
sick_safevisionary_interfaces__msg__DeviceStatus__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__DeviceStatus__Sequence * array = (sick_safevisionary_interfaces__msg__DeviceStatus__Sequence *)allocator.allocate(sizeof(sick_safevisionary_interfaces__msg__DeviceStatus__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = sick_safevisionary_interfaces__msg__DeviceStatus__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
sick_safevisionary_interfaces__msg__DeviceStatus__Sequence__destroy(sick_safevisionary_interfaces__msg__DeviceStatus__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    sick_safevisionary_interfaces__msg__DeviceStatus__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
sick_safevisionary_interfaces__msg__DeviceStatus__Sequence__are_equal(const sick_safevisionary_interfaces__msg__DeviceStatus__Sequence * lhs, const sick_safevisionary_interfaces__msg__DeviceStatus__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!sick_safevisionary_interfaces__msg__DeviceStatus__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
sick_safevisionary_interfaces__msg__DeviceStatus__Sequence__copy(
  const sick_safevisionary_interfaces__msg__DeviceStatus__Sequence * input,
  sick_safevisionary_interfaces__msg__DeviceStatus__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(sick_safevisionary_interfaces__msg__DeviceStatus);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    sick_safevisionary_interfaces__msg__DeviceStatus * data =
      (sick_safevisionary_interfaces__msg__DeviceStatus *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!sick_safevisionary_interfaces__msg__DeviceStatus__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          sick_safevisionary_interfaces__msg__DeviceStatus__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!sick_safevisionary_interfaces__msg__DeviceStatus__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
