// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from sick_safevisionary_interfaces:msg/DeviceStatus.idl
// generated code does not contain a copyright notice

#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__DEVICE_STATUS__STRUCT_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__DEVICE_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'general_status'
#include "sick_safevisionary_interfaces/msg/detail/general_status__struct.hpp"
// Member 'active_monitoring_case'
#include "sick_safevisionary_interfaces/msg/detail/active_monitoring_case__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__sick_safevisionary_interfaces__msg__DeviceStatus __attribute__((deprecated))
#else
# define DEPRECATED__sick_safevisionary_interfaces__msg__DeviceStatus __declspec(deprecated)
#endif

namespace sick_safevisionary_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DeviceStatus_
{
  using Type = DeviceStatus_<ContainerAllocator>;

  explicit DeviceStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    general_status(_init),
    active_monitoring_case(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
      this->cop_safety_related = 0ul;
      this->cop_non_safety_related = 0ul;
      this->cop_reset_required = 0ul;
      this->contamination_level = 0;
    }
  }

  explicit DeviceStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    general_status(_alloc, _init),
    active_monitoring_case(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
      this->cop_safety_related = 0ul;
      this->cop_non_safety_related = 0ul;
      this->cop_reset_required = 0ul;
      this->contamination_level = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _status_type =
    uint8_t;
  _status_type status;
  using _general_status_type =
    sick_safevisionary_interfaces::msg::GeneralStatus_<ContainerAllocator>;
  _general_status_type general_status;
  using _cop_safety_related_type =
    uint32_t;
  _cop_safety_related_type cop_safety_related;
  using _cop_non_safety_related_type =
    uint32_t;
  _cop_non_safety_related_type cop_non_safety_related;
  using _cop_reset_required_type =
    uint32_t;
  _cop_reset_required_type cop_reset_required;
  using _active_monitoring_case_type =
    sick_safevisionary_interfaces::msg::ActiveMonitoringCase_<ContainerAllocator>;
  _active_monitoring_case_type active_monitoring_case;
  using _contamination_level_type =
    uint8_t;
  _contamination_level_type contamination_level;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__status(
    const uint8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__general_status(
    const sick_safevisionary_interfaces::msg::GeneralStatus_<ContainerAllocator> & _arg)
  {
    this->general_status = _arg;
    return *this;
  }
  Type & set__cop_safety_related(
    const uint32_t & _arg)
  {
    this->cop_safety_related = _arg;
    return *this;
  }
  Type & set__cop_non_safety_related(
    const uint32_t & _arg)
  {
    this->cop_non_safety_related = _arg;
    return *this;
  }
  Type & set__cop_reset_required(
    const uint32_t & _arg)
  {
    this->cop_reset_required = _arg;
    return *this;
  }
  Type & set__active_monitoring_case(
    const sick_safevisionary_interfaces::msg::ActiveMonitoringCase_<ContainerAllocator> & _arg)
  {
    this->active_monitoring_case = _arg;
    return *this;
  }
  Type & set__contamination_level(
    const uint8_t & _arg)
  {
    this->contamination_level = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    sick_safevisionary_interfaces::msg::DeviceStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const sick_safevisionary_interfaces::msg::DeviceStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::DeviceStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::DeviceStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::DeviceStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::DeviceStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::DeviceStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::DeviceStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::DeviceStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::DeviceStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__DeviceStatus
    std::shared_ptr<sick_safevisionary_interfaces::msg::DeviceStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__DeviceStatus
    std::shared_ptr<sick_safevisionary_interfaces::msg::DeviceStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DeviceStatus_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->status != other.status) {
      return false;
    }
    if (this->general_status != other.general_status) {
      return false;
    }
    if (this->cop_safety_related != other.cop_safety_related) {
      return false;
    }
    if (this->cop_non_safety_related != other.cop_non_safety_related) {
      return false;
    }
    if (this->cop_reset_required != other.cop_reset_required) {
      return false;
    }
    if (this->active_monitoring_case != other.active_monitoring_case) {
      return false;
    }
    if (this->contamination_level != other.contamination_level) {
      return false;
    }
    return true;
  }
  bool operator!=(const DeviceStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DeviceStatus_

// alias to use template instance with default allocator
using DeviceStatus =
  sick_safevisionary_interfaces::msg::DeviceStatus_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__DEVICE_STATUS__STRUCT_HPP_
