// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from sick_safevisionary_interfaces:msg/FieldInformationArray.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "sick_safevisionary_interfaces/msg/detail/field_information_array__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace sick_safevisionary_interfaces
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void FieldInformationArray_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) sick_safevisionary_interfaces::msg::FieldInformationArray(_init);
}

void FieldInformationArray_fini_function(void * message_memory)
{
  auto typed_message = static_cast<sick_safevisionary_interfaces::msg::FieldInformationArray *>(message_memory);
  typed_message->~FieldInformationArray();
}

size_t size_function__FieldInformationArray__fields(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<sick_safevisionary_interfaces::msg::FieldInformation> *>(untyped_member);
  return member->size();
}

const void * get_const_function__FieldInformationArray__fields(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<sick_safevisionary_interfaces::msg::FieldInformation> *>(untyped_member);
  return &member[index];
}

void * get_function__FieldInformationArray__fields(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<sick_safevisionary_interfaces::msg::FieldInformation> *>(untyped_member);
  return &member[index];
}

void fetch_function__FieldInformationArray__fields(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const sick_safevisionary_interfaces::msg::FieldInformation *>(
    get_const_function__FieldInformationArray__fields(untyped_member, index));
  auto & value = *reinterpret_cast<sick_safevisionary_interfaces::msg::FieldInformation *>(untyped_value);
  value = item;
}

void assign_function__FieldInformationArray__fields(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<sick_safevisionary_interfaces::msg::FieldInformation *>(
    get_function__FieldInformationArray__fields(untyped_member, index));
  const auto & value = *reinterpret_cast<const sick_safevisionary_interfaces::msg::FieldInformation *>(untyped_value);
  item = value;
}

void resize_function__FieldInformationArray__fields(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<sick_safevisionary_interfaces::msg::FieldInformation> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember FieldInformationArray_message_member_array[2] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(sick_safevisionary_interfaces::msg::FieldInformationArray, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "fields",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<sick_safevisionary_interfaces::msg::FieldInformation>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(sick_safevisionary_interfaces::msg::FieldInformationArray, fields),  // bytes offset in struct
    nullptr,  // default value
    size_function__FieldInformationArray__fields,  // size() function pointer
    get_const_function__FieldInformationArray__fields,  // get_const(index) function pointer
    get_function__FieldInformationArray__fields,  // get(index) function pointer
    fetch_function__FieldInformationArray__fields,  // fetch(index, &value) function pointer
    assign_function__FieldInformationArray__fields,  // assign(index, value) function pointer
    resize_function__FieldInformationArray__fields  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers FieldInformationArray_message_members = {
  "sick_safevisionary_interfaces::msg",  // message namespace
  "FieldInformationArray",  // message name
  2,  // number of fields
  sizeof(sick_safevisionary_interfaces::msg::FieldInformationArray),
  FieldInformationArray_message_member_array,  // message members
  FieldInformationArray_init_function,  // function to initialize message memory (memory has to be allocated)
  FieldInformationArray_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t FieldInformationArray_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &FieldInformationArray_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace sick_safevisionary_interfaces


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<sick_safevisionary_interfaces::msg::FieldInformationArray>()
{
  return &::sick_safevisionary_interfaces::msg::rosidl_typesupport_introspection_cpp::FieldInformationArray_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, sick_safevisionary_interfaces, msg, FieldInformationArray)() {
  return &::sick_safevisionary_interfaces::msg::rosidl_typesupport_introspection_cpp::FieldInformationArray_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
