// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from sick_safevisionary_interfaces:msg/GeneralStatus.idl
// generated code does not contain a copyright notice

#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__GENERAL_STATUS__BUILDER_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__GENERAL_STATUS__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "sick_safevisionary_interfaces/msg/detail/general_status__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace sick_safevisionary_interfaces
{

namespace msg
{

namespace builder
{

class Init_GeneralStatus_temperature_warning
{
public:
  explicit Init_GeneralStatus_temperature_warning(::sick_safevisionary_interfaces::msg::GeneralStatus & msg)
  : msg_(msg)
  {}
  ::sick_safevisionary_interfaces::msg::GeneralStatus temperature_warning(::sick_safevisionary_interfaces::msg::GeneralStatus::_temperature_warning_type arg)
  {
    msg_.temperature_warning = std::move(arg);
    return std::move(msg_);
  }

private:
  ::sick_safevisionary_interfaces::msg::GeneralStatus msg_;
};

class Init_GeneralStatus_dead_zone_detection
{
public:
  explicit Init_GeneralStatus_dead_zone_detection(::sick_safevisionary_interfaces::msg::GeneralStatus & msg)
  : msg_(msg)
  {}
  Init_GeneralStatus_temperature_warning dead_zone_detection(::sick_safevisionary_interfaces::msg::GeneralStatus::_dead_zone_detection_type arg)
  {
    msg_.dead_zone_detection = std::move(arg);
    return Init_GeneralStatus_temperature_warning(msg_);
  }

private:
  ::sick_safevisionary_interfaces::msg::GeneralStatus msg_;
};

class Init_GeneralStatus_contamination_error
{
public:
  explicit Init_GeneralStatus_contamination_error(::sick_safevisionary_interfaces::msg::GeneralStatus & msg)
  : msg_(msg)
  {}
  Init_GeneralStatus_dead_zone_detection contamination_error(::sick_safevisionary_interfaces::msg::GeneralStatus::_contamination_error_type arg)
  {
    msg_.contamination_error = std::move(arg);
    return Init_GeneralStatus_dead_zone_detection(msg_);
  }

private:
  ::sick_safevisionary_interfaces::msg::GeneralStatus msg_;
};

class Init_GeneralStatus_contamination_warning
{
public:
  explicit Init_GeneralStatus_contamination_warning(::sick_safevisionary_interfaces::msg::GeneralStatus & msg)
  : msg_(msg)
  {}
  Init_GeneralStatus_contamination_error contamination_warning(::sick_safevisionary_interfaces::msg::GeneralStatus::_contamination_warning_type arg)
  {
    msg_.contamination_warning = std::move(arg);
    return Init_GeneralStatus_contamination_error(msg_);
  }

private:
  ::sick_safevisionary_interfaces::msg::GeneralStatus msg_;
};

class Init_GeneralStatus_wait_for_cluster
{
public:
  explicit Init_GeneralStatus_wait_for_cluster(::sick_safevisionary_interfaces::msg::GeneralStatus & msg)
  : msg_(msg)
  {}
  Init_GeneralStatus_contamination_warning wait_for_cluster(::sick_safevisionary_interfaces::msg::GeneralStatus::_wait_for_cluster_type arg)
  {
    msg_.wait_for_cluster = std::move(arg);
    return Init_GeneralStatus_contamination_warning(msg_);
  }

private:
  ::sick_safevisionary_interfaces::msg::GeneralStatus msg_;
};

class Init_GeneralStatus_wait_for_input
{
public:
  explicit Init_GeneralStatus_wait_for_input(::sick_safevisionary_interfaces::msg::GeneralStatus & msg)
  : msg_(msg)
  {}
  Init_GeneralStatus_wait_for_cluster wait_for_input(::sick_safevisionary_interfaces::msg::GeneralStatus::_wait_for_input_type arg)
  {
    msg_.wait_for_input = std::move(arg);
    return Init_GeneralStatus_wait_for_cluster(msg_);
  }

private:
  ::sick_safevisionary_interfaces::msg::GeneralStatus msg_;
};

class Init_GeneralStatus_sleep_mode
{
public:
  explicit Init_GeneralStatus_sleep_mode(::sick_safevisionary_interfaces::msg::GeneralStatus & msg)
  : msg_(msg)
  {}
  Init_GeneralStatus_wait_for_input sleep_mode(::sick_safevisionary_interfaces::msg::GeneralStatus::_sleep_mode_type arg)
  {
    msg_.sleep_mode = std::move(arg);
    return Init_GeneralStatus_wait_for_input(msg_);
  }

private:
  ::sick_safevisionary_interfaces::msg::GeneralStatus msg_;
};

class Init_GeneralStatus_application_error
{
public:
  explicit Init_GeneralStatus_application_error(::sick_safevisionary_interfaces::msg::GeneralStatus & msg)
  : msg_(msg)
  {}
  Init_GeneralStatus_sleep_mode application_error(::sick_safevisionary_interfaces::msg::GeneralStatus::_application_error_type arg)
  {
    msg_.application_error = std::move(arg);
    return Init_GeneralStatus_sleep_mode(msg_);
  }

private:
  ::sick_safevisionary_interfaces::msg::GeneralStatus msg_;
};

class Init_GeneralStatus_device_error
{
public:
  explicit Init_GeneralStatus_device_error(::sick_safevisionary_interfaces::msg::GeneralStatus & msg)
  : msg_(msg)
  {}
  Init_GeneralStatus_application_error device_error(::sick_safevisionary_interfaces::msg::GeneralStatus::_device_error_type arg)
  {
    msg_.device_error = std::move(arg);
    return Init_GeneralStatus_application_error(msg_);
  }

private:
  ::sick_safevisionary_interfaces::msg::GeneralStatus msg_;
};

class Init_GeneralStatus_run_mode_active
{
public:
  Init_GeneralStatus_run_mode_active()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_GeneralStatus_device_error run_mode_active(::sick_safevisionary_interfaces::msg::GeneralStatus::_run_mode_active_type arg)
  {
    msg_.run_mode_active = std::move(arg);
    return Init_GeneralStatus_device_error(msg_);
  }

private:
  ::sick_safevisionary_interfaces::msg::GeneralStatus msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::sick_safevisionary_interfaces::msg::GeneralStatus>()
{
  return sick_safevisionary_interfaces::msg::builder::Init_GeneralStatus_run_mode_active();
}

}  // namespace sick_safevisionary_interfaces

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__GENERAL_STATUS__BUILDER_HPP_
