// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safevisionary_interfaces:msg/IOOSSDSState.idl
// generated code does not contain a copyright notice
#include "sick_safevisionary_interfaces/msg/detail/ioossds_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
sick_safevisionary_interfaces__msg__IOOSSDSState__init(sick_safevisionary_interfaces__msg__IOOSSDSState * msg)
{
  if (!msg) {
    return false;
  }
  // ossd1a
  // ossd1b
  // ossd2a
  // ossd2b
  return true;
}

void
sick_safevisionary_interfaces__msg__IOOSSDSState__fini(sick_safevisionary_interfaces__msg__IOOSSDSState * msg)
{
  if (!msg) {
    return;
  }
  // ossd1a
  // ossd1b
  // ossd2a
  // ossd2b
}

bool
sick_safevisionary_interfaces__msg__IOOSSDSState__are_equal(const sick_safevisionary_interfaces__msg__IOOSSDSState * lhs, const sick_safevisionary_interfaces__msg__IOOSSDSState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // ossd1a
  if (lhs->ossd1a != rhs->ossd1a) {
    return false;
  }
  // ossd1b
  if (lhs->ossd1b != rhs->ossd1b) {
    return false;
  }
  // ossd2a
  if (lhs->ossd2a != rhs->ossd2a) {
    return false;
  }
  // ossd2b
  if (lhs->ossd2b != rhs->ossd2b) {
    return false;
  }
  return true;
}

bool
sick_safevisionary_interfaces__msg__IOOSSDSState__copy(
  const sick_safevisionary_interfaces__msg__IOOSSDSState * input,
  sick_safevisionary_interfaces__msg__IOOSSDSState * output)
{
  if (!input || !output) {
    return false;
  }
  // ossd1a
  output->ossd1a = input->ossd1a;
  // ossd1b
  output->ossd1b = input->ossd1b;
  // ossd2a
  output->ossd2a = input->ossd2a;
  // ossd2b
  output->ossd2b = input->ossd2b;
  return true;
}

sick_safevisionary_interfaces__msg__IOOSSDSState *
sick_safevisionary_interfaces__msg__IOOSSDSState__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__IOOSSDSState * msg = (sick_safevisionary_interfaces__msg__IOOSSDSState *)allocator.allocate(sizeof(sick_safevisionary_interfaces__msg__IOOSSDSState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safevisionary_interfaces__msg__IOOSSDSState));
  bool success = sick_safevisionary_interfaces__msg__IOOSSDSState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
sick_safevisionary_interfaces__msg__IOOSSDSState__destroy(sick_safevisionary_interfaces__msg__IOOSSDSState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    sick_safevisionary_interfaces__msg__IOOSSDSState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence__init(sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__IOOSSDSState * data = NULL;

  if (size) {
    data = (sick_safevisionary_interfaces__msg__IOOSSDSState *)allocator.zero_allocate(size, sizeof(sick_safevisionary_interfaces__msg__IOOSSDSState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safevisionary_interfaces__msg__IOOSSDSState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safevisionary_interfaces__msg__IOOSSDSState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence__fini(sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safevisionary_interfaces__msg__IOOSSDSState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence *
sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence * array = (sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence *)allocator.allocate(sizeof(sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence__destroy(sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence__are_equal(const sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence * lhs, const sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!sick_safevisionary_interfaces__msg__IOOSSDSState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence__copy(
  const sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence * input,
  sick_safevisionary_interfaces__msg__IOOSSDSState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(sick_safevisionary_interfaces__msg__IOOSSDSState);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    sick_safevisionary_interfaces__msg__IOOSSDSState * data =
      (sick_safevisionary_interfaces__msg__IOOSSDSState *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!sick_safevisionary_interfaces__msg__IOOSSDSState__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          sick_safevisionary_interfaces__msg__IOOSSDSState__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!sick_safevisionary_interfaces__msg__IOOSSDSState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
