// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safevisionary_interfaces:msg/ROI.idl
// generated code does not contain a copyright notice
#include "sick_safevisionary_interfaces/msg/detail/roi__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `result_data`
#include "sick_safevisionary_interfaces/msg/detail/roi_observation_result_data__functions.h"
// Member `safety_data`
#include "sick_safevisionary_interfaces/msg/detail/roi_observation_safety_data__functions.h"

bool
sick_safevisionary_interfaces__msg__ROI__init(sick_safevisionary_interfaces__msg__ROI * msg)
{
  if (!msg) {
    return false;
  }
  // id
  // result_data
  if (!sick_safevisionary_interfaces__msg__ROIObservationResultData__init(&msg->result_data)) {
    sick_safevisionary_interfaces__msg__ROI__fini(msg);
    return false;
  }
  // safety_data
  if (!sick_safevisionary_interfaces__msg__ROIObservationSafetyData__init(&msg->safety_data)) {
    sick_safevisionary_interfaces__msg__ROI__fini(msg);
    return false;
  }
  // distance_value
  return true;
}

void
sick_safevisionary_interfaces__msg__ROI__fini(sick_safevisionary_interfaces__msg__ROI * msg)
{
  if (!msg) {
    return;
  }
  // id
  // result_data
  sick_safevisionary_interfaces__msg__ROIObservationResultData__fini(&msg->result_data);
  // safety_data
  sick_safevisionary_interfaces__msg__ROIObservationSafetyData__fini(&msg->safety_data);
  // distance_value
}

bool
sick_safevisionary_interfaces__msg__ROI__are_equal(const sick_safevisionary_interfaces__msg__ROI * lhs, const sick_safevisionary_interfaces__msg__ROI * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // result_data
  if (!sick_safevisionary_interfaces__msg__ROIObservationResultData__are_equal(
      &(lhs->result_data), &(rhs->result_data)))
  {
    return false;
  }
  // safety_data
  if (!sick_safevisionary_interfaces__msg__ROIObservationSafetyData__are_equal(
      &(lhs->safety_data), &(rhs->safety_data)))
  {
    return false;
  }
  // distance_value
  if (lhs->distance_value != rhs->distance_value) {
    return false;
  }
  return true;
}

bool
sick_safevisionary_interfaces__msg__ROI__copy(
  const sick_safevisionary_interfaces__msg__ROI * input,
  sick_safevisionary_interfaces__msg__ROI * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  output->id = input->id;
  // result_data
  if (!sick_safevisionary_interfaces__msg__ROIObservationResultData__copy(
      &(input->result_data), &(output->result_data)))
  {
    return false;
  }
  // safety_data
  if (!sick_safevisionary_interfaces__msg__ROIObservationSafetyData__copy(
      &(input->safety_data), &(output->safety_data)))
  {
    return false;
  }
  // distance_value
  output->distance_value = input->distance_value;
  return true;
}

sick_safevisionary_interfaces__msg__ROI *
sick_safevisionary_interfaces__msg__ROI__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__ROI * msg = (sick_safevisionary_interfaces__msg__ROI *)allocator.allocate(sizeof(sick_safevisionary_interfaces__msg__ROI), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safevisionary_interfaces__msg__ROI));
  bool success = sick_safevisionary_interfaces__msg__ROI__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
sick_safevisionary_interfaces__msg__ROI__destroy(sick_safevisionary_interfaces__msg__ROI * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    sick_safevisionary_interfaces__msg__ROI__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
sick_safevisionary_interfaces__msg__ROI__Sequence__init(sick_safevisionary_interfaces__msg__ROI__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__ROI * data = NULL;

  if (size) {
    data = (sick_safevisionary_interfaces__msg__ROI *)allocator.zero_allocate(size, sizeof(sick_safevisionary_interfaces__msg__ROI), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safevisionary_interfaces__msg__ROI__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safevisionary_interfaces__msg__ROI__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safevisionary_interfaces__msg__ROI__Sequence__fini(sick_safevisionary_interfaces__msg__ROI__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safevisionary_interfaces__msg__ROI__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safevisionary_interfaces__msg__ROI__Sequence *
sick_safevisionary_interfaces__msg__ROI__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__ROI__Sequence * array = (sick_safevisionary_interfaces__msg__ROI__Sequence *)allocator.allocate(sizeof(sick_safevisionary_interfaces__msg__ROI__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = sick_safevisionary_interfaces__msg__ROI__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
sick_safevisionary_interfaces__msg__ROI__Sequence__destroy(sick_safevisionary_interfaces__msg__ROI__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    sick_safevisionary_interfaces__msg__ROI__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
sick_safevisionary_interfaces__msg__ROI__Sequence__are_equal(const sick_safevisionary_interfaces__msg__ROI__Sequence * lhs, const sick_safevisionary_interfaces__msg__ROI__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!sick_safevisionary_interfaces__msg__ROI__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
sick_safevisionary_interfaces__msg__ROI__Sequence__copy(
  const sick_safevisionary_interfaces__msg__ROI__Sequence * input,
  sick_safevisionary_interfaces__msg__ROI__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(sick_safevisionary_interfaces__msg__ROI);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    sick_safevisionary_interfaces__msg__ROI * data =
      (sick_safevisionary_interfaces__msg__ROI *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!sick_safevisionary_interfaces__msg__ROI__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          sick_safevisionary_interfaces__msg__ROI__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!sick_safevisionary_interfaces__msg__ROI__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
