// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from sick_safevisionary_interfaces:msg/ROI.idl
// generated code does not contain a copyright notice

#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI__TRAITS_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "sick_safevisionary_interfaces/msg/detail/roi__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'result_data'
#include "sick_safevisionary_interfaces/msg/detail/roi_observation_result_data__traits.hpp"
// Member 'safety_data'
#include "sick_safevisionary_interfaces/msg/detail/roi_observation_safety_data__traits.hpp"

namespace sick_safevisionary_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const ROI & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: result_data
  {
    out << "result_data: ";
    to_flow_style_yaml(msg.result_data, out);
    out << ", ";
  }

  // member: safety_data
  {
    out << "safety_data: ";
    to_flow_style_yaml(msg.safety_data, out);
    out << ", ";
  }

  // member: distance_value
  {
    out << "distance_value: ";
    rosidl_generator_traits::value_to_yaml(msg.distance_value, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ROI & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: result_data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result_data:\n";
    to_block_style_yaml(msg.result_data, out, indentation + 2);
  }

  // member: safety_data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "safety_data:\n";
    to_block_style_yaml(msg.safety_data, out, indentation + 2);
  }

  // member: distance_value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "distance_value: ";
    rosidl_generator_traits::value_to_yaml(msg.distance_value, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ROI & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use sick_safevisionary_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const sick_safevisionary_interfaces::msg::ROI & msg,
  std::ostream & out, size_t indentation = 0)
{
  sick_safevisionary_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use sick_safevisionary_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const sick_safevisionary_interfaces::msg::ROI & msg)
{
  return sick_safevisionary_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<sick_safevisionary_interfaces::msg::ROI>()
{
  return "sick_safevisionary_interfaces::msg::ROI";
}

template<>
inline const char * name<sick_safevisionary_interfaces::msg::ROI>()
{
  return "sick_safevisionary_interfaces/msg/ROI";
}

template<>
struct has_fixed_size<sick_safevisionary_interfaces::msg::ROI>
  : std::integral_constant<bool, has_fixed_size<sick_safevisionary_interfaces::msg::ROIObservationResultData>::value && has_fixed_size<sick_safevisionary_interfaces::msg::ROIObservationSafetyData>::value> {};

template<>
struct has_bounded_size<sick_safevisionary_interfaces::msg::ROI>
  : std::integral_constant<bool, has_bounded_size<sick_safevisionary_interfaces::msg::ROIObservationResultData>::value && has_bounded_size<sick_safevisionary_interfaces::msg::ROIObservationSafetyData>::value> {};

template<>
struct is_message<sick_safevisionary_interfaces::msg::ROI>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI__TRAITS_HPP_
