// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from sick_safevisionary_interfaces:msg/ROIObservationSafetyData.idl
// generated code does not contain a copyright notice

#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI_OBSERVATION_SAFETY_DATA__TRAITS_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI_OBSERVATION_SAFETY_DATA__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "sick_safevisionary_interfaces/msg/detail/roi_observation_safety_data__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace sick_safevisionary_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const ROIObservationSafetyData & msg,
  std::ostream & out)
{
  out << "{";
  // member: invalid_due_to_invalid_pixels
  {
    out << "invalid_due_to_invalid_pixels: ";
    rosidl_generator_traits::value_to_yaml(msg.invalid_due_to_invalid_pixels, out);
    out << ", ";
  }

  // member: invalid_due_to_variance
  {
    out << "invalid_due_to_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.invalid_due_to_variance, out);
    out << ", ";
  }

  // member: invalid_due_to_overexposure
  {
    out << "invalid_due_to_overexposure: ";
    rosidl_generator_traits::value_to_yaml(msg.invalid_due_to_overexposure, out);
    out << ", ";
  }

  // member: invalid_due_to_underexposure
  {
    out << "invalid_due_to_underexposure: ";
    rosidl_generator_traits::value_to_yaml(msg.invalid_due_to_underexposure, out);
    out << ", ";
  }

  // member: invalid_due_to_temporal_variance
  {
    out << "invalid_due_to_temporal_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.invalid_due_to_temporal_variance, out);
    out << ", ";
  }

  // member: invalid_due_to_outside_of_measurement_range
  {
    out << "invalid_due_to_outside_of_measurement_range: ";
    rosidl_generator_traits::value_to_yaml(msg.invalid_due_to_outside_of_measurement_range, out);
    out << ", ";
  }

  // member: invalid_due_to_retro_reflector_interference
  {
    out << "invalid_due_to_retro_reflector_interference: ";
    rosidl_generator_traits::value_to_yaml(msg.invalid_due_to_retro_reflector_interference, out);
    out << ", ";
  }

  // member: contamination_error
  {
    out << "contamination_error: ";
    rosidl_generator_traits::value_to_yaml(msg.contamination_error, out);
    out << ", ";
  }

  // member: quality_class
  {
    out << "quality_class: ";
    rosidl_generator_traits::value_to_yaml(msg.quality_class, out);
    out << ", ";
  }

  // member: slot_active
  {
    out << "slot_active: ";
    rosidl_generator_traits::value_to_yaml(msg.slot_active, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ROIObservationSafetyData & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: invalid_due_to_invalid_pixels
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "invalid_due_to_invalid_pixels: ";
    rosidl_generator_traits::value_to_yaml(msg.invalid_due_to_invalid_pixels, out);
    out << "\n";
  }

  // member: invalid_due_to_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "invalid_due_to_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.invalid_due_to_variance, out);
    out << "\n";
  }

  // member: invalid_due_to_overexposure
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "invalid_due_to_overexposure: ";
    rosidl_generator_traits::value_to_yaml(msg.invalid_due_to_overexposure, out);
    out << "\n";
  }

  // member: invalid_due_to_underexposure
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "invalid_due_to_underexposure: ";
    rosidl_generator_traits::value_to_yaml(msg.invalid_due_to_underexposure, out);
    out << "\n";
  }

  // member: invalid_due_to_temporal_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "invalid_due_to_temporal_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.invalid_due_to_temporal_variance, out);
    out << "\n";
  }

  // member: invalid_due_to_outside_of_measurement_range
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "invalid_due_to_outside_of_measurement_range: ";
    rosidl_generator_traits::value_to_yaml(msg.invalid_due_to_outside_of_measurement_range, out);
    out << "\n";
  }

  // member: invalid_due_to_retro_reflector_interference
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "invalid_due_to_retro_reflector_interference: ";
    rosidl_generator_traits::value_to_yaml(msg.invalid_due_to_retro_reflector_interference, out);
    out << "\n";
  }

  // member: contamination_error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "contamination_error: ";
    rosidl_generator_traits::value_to_yaml(msg.contamination_error, out);
    out << "\n";
  }

  // member: quality_class
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "quality_class: ";
    rosidl_generator_traits::value_to_yaml(msg.quality_class, out);
    out << "\n";
  }

  // member: slot_active
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "slot_active: ";
    rosidl_generator_traits::value_to_yaml(msg.slot_active, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ROIObservationSafetyData & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use sick_safevisionary_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const sick_safevisionary_interfaces::msg::ROIObservationSafetyData & msg,
  std::ostream & out, size_t indentation = 0)
{
  sick_safevisionary_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use sick_safevisionary_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const sick_safevisionary_interfaces::msg::ROIObservationSafetyData & msg)
{
  return sick_safevisionary_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<sick_safevisionary_interfaces::msg::ROIObservationSafetyData>()
{
  return "sick_safevisionary_interfaces::msg::ROIObservationSafetyData";
}

template<>
inline const char * name<sick_safevisionary_interfaces::msg::ROIObservationSafetyData>()
{
  return "sick_safevisionary_interfaces/msg/ROIObservationSafetyData";
}

template<>
struct has_fixed_size<sick_safevisionary_interfaces::msg::ROIObservationSafetyData>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<sick_safevisionary_interfaces::msg::ROIObservationSafetyData>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<sick_safevisionary_interfaces::msg::ROIObservationSafetyData>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI_OBSERVATION_SAFETY_DATA__TRAITS_HPP_
